<?php
/**
* @author   Vasatko
* @version  1.0
* @remarks  Copyright (C) 2011 Vasatko
* @remarks  Licensed under GNU/GPLv3, see http://www.gnu.org/licenses/gpl-3.0.html
* @see      http://vasatko.net/joomla/mapycz
*/

// no direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.controller');

/**
 * MapyCZ Controller
 */
class MapyCZController extends JControllerLegacy{

	public function markerlinks(){
		
		// load map id
		$mapId = JRequest::getVar('mapId');
		$function = JRequest::getVar('function');
		$name = JRequest::getVar('name');
		$error="";
		
		// if form is sended
		if($function!=null && $function!=''){
			
			JRequest::checkToken() or jexit(JText::_('JInvalid_Token'));
			
			$map = JRequest::getVar('map');
			$marker = JRequest::getVar('marker');
			$text = JRequest::getVar('text');
			$zoom = JRequest::getVar('zoom');
			$layer = JRequest::getVar('layer');	

			if($map==""){
				$error = '<span style="color:#cd061e;">'.JText::_('MAPYCZ_MARK_LINK_MAP_VALID').'</span>';
			}else if($marker==""){
				$error = '<span style="color:#cd061e;">'.JText::_('MAPYCZ_MARK_LINK_MARKER_VALID').'</span>';
			}else{
				$js = "if (window.parent) window.parent.jFinishLink('".$name."', '".$map."', '".$marker."', '".$text."', '".$zoom."', '".$layer."');";
				echo "<script>".$js."</script>";
			}
		}
		
		// get the document object
		$document	= JFactory::getDocument();

		// get the view
		$view = $this->getView("markers", $document->getType());
	
		// set model for map list and get it into the view
		$model = $this->getModel("markers");
		$view->setModel($model, true);
	
		// set layout
		$view->setLayout("marker-link");

		// set document object into the view
		$view->assignRef('document', $document);
		$view->assignRef('error', $error);
		
		// show
		$view->display();
		/*
		
		
		// get view object for markers
		$view = $this->getView("markers", $document->getType());
		
		// get model object for markers
		$model = $this->getModel("maps");
		$view->setModel($model, true);
		
		// set layout
		$view->setLayout("marker-link");

		// set document object into the view
		$view->assignRef('document', $document);
					
		// show
		$view->display();
	*/
	}
	
	public function markersSelectbox(){
		
		// load map id
		$mapId = JRequest::getVar('mapId');
		$function = JRequest::getVar('function');
		
		// get document object
		$document	= JFactory::getDocument();
		
		// get view object for markers
		$view = $this->getView("markers", $document->getType());
		
		// get model object for markers
		$model = $this->getModel('markers');
		
		// load markers data for selected map
		$model->setMapId($mapId);
		
		// set model object into the view
		$view->setModel($model, true);
		
		// set layout
		$view->setLayout("markers-selectbox");

		// set document object into the view
		$view->assignRef('document', $document);
			
		// show
		$view->display();
		
	}
	
	/** function, that show map list */
	public function display($cachable = false, $urlparams = false){

		// get the document object
		$document	= JFactory::getDocument();

		// get the view
		$view = $this->getView("maps", $document->getType());
	
		// set model for map list and get it into the view
		$model = $this->getModel("maps");
		$view->setModel($model, true);
	
		// set layout
		$view->setLayout("default");

		// set document object into the view
		$view->assignRef('document', $document);
		
		// show
		$view->display();
	
	}

	/** function, that open new map in edit form */
	public function add(){
	
		// load map id
		$cid = JRequest::getVar('cid');
		
		// get document object
		$document	= JFactory::getDocument();
		
		// get view object for map
		$view = $this->getView("map", $document->getType());
		
		// get model object for map
		$model = $this->getModel('map');
		
		// load empty map data
		$model->newMap();
		
		// set modle object into the view
		$view->setModel($model, true);
		
		// set layout
		$view->setLayout("default");

		// set document object into the view
		$view->assignRef('document', $document);
			
		// show
		$view->display();
		
	}
	
	/** function, that show selected map in edit form */
	public function show(){
	
		// load map id
		$cid = JRequest::getVar('cid');
		
		if(is_array($cid)){
			$cid=$cid[0];
		}
		
		// get document object
		$document	= JFactory::getDocument();
		
		// get view object for map
		$view = $this->getView("map", $document->getType());
		
		// get model object for map
		$model = $this->getModel('map');
		
		// load selected map data
		$model->loadMap($cid);
		
		// set modle object into the view
		$view->setModel($model, true);
		
		// set layout
		$view->setLayout("default");

		// set document object into the view
		$view->assignRef('document', $document);
			
		// show
		$view->display();
		
	}
	
	/** function, that save data about map in edit form */
	public function save(){
	
		// check for request forgeries
		JRequest::checkToken() or jexit(JText::_('JInvalid_Token'));
		
		// load map data from request
		$cid = JRequest::getVar('cid');
		$name = JRequest::getVar('name');
		$zoom = JRequest::getVar('zoom');
		$layer = JRequest::getVar('layer');
		$height = JRequest::getVar('height');
		$width = JRequest::getVar('width');
		$width_responsive = JRequest::getVar('width_responsive');
		$turist_ped = JRequest::getVar('turist_ped');
		$turist_cyc = JRequest::getVar('turist_cyc');
		$longitude = JRequest::getVar('longitude');
		$latitude = JRequest::getVar('latitude');
		$controls = JRequest::getVar('controls');
		$clusterer = JRequest::getVar('clusterer');
		
		// get model object for map
		$model = $this->getModel('map');
		
		// save map
		$map = $model->editMap($cid,$name,$zoom,$layer,$width,$width_responsive,$height,$longitude,$latitude,$controls,$clusterer,$turist_ped,$turist_cyc);
		
		echo "<div id='newMapId'>".$map->id."</div>";exit;
		
		// redirect to map list
		//$this->setRedirect('index.php?option=com_mapycz');
	}
	
	/** function that remove selected map(s) */
	public function delete(){
	
		// check for request forgeries
		JRequest::checkToken() or jexit(JText::_('JInvalid_Token'));
		
		//echo "<pre>";print_r($_REQUEST);echo "</pre>";exit;
		$cid = JRequest::getVar('cid');
		
		// get model object for map
		$model = $this->getModel('map');
		// remove selected map
		$model->deleteMap($cid);
		
		// redirect to map list
		$this->setRedirect('index.php?option=com_mapycz');
	}
	
	/** function, that show markers list of selected map */
	public function markers(){
	
		// load map id
		$mapId = JRequest::getVar('mapId');
		
		// get document object
		$document	= JFactory::getDocument();
		
		// get view object for markers
		$view = $this->getView("markers", $document->getType());
		
		// get model object for markers
		$model = $this->getModel('markers');
		
		// load markers data for selected map
		$model->setMapId($mapId);
		
		// set model object into the view
		$view->setModel($model, true);
		
		// set layout
		$view->setLayout("default");

		// set document object into the view
		$view->assignRef('document', $document);
			
		// show
		$view->display();
		
	}
	
}
